import { OverlayTemplate } from 'klinecharts/src/component/Overlay.js';

const enum AnnotationVAling {
  ABOVE = 'above',
  BELOW = 'below'
}

interface AnnotationAttr {
  text: string
  vAlign: AnnotationVAling
}

const annotation: OverlayTemplate = {
  name: 'annotation',
  createPointFigures: ({ overlay, coordinates }) => {
    const attr = overlay.extendData(overlay) as AnnotationAttr
    if (attr.vAlign == AnnotationVAling.BELOW) {
      const startX = coordinates[0].x
      const startY = coordinates[0].y + 6
      const lineEndY = startY + 70
      const arrowEndY = lineEndY - 5

      return [
        {
          type: 'line',
          attrs: { coordinates: [{ x: startX, y: startY }, { x: startX, y: lineEndY }] },
          ignoreEvent: true
        },
        {
          type: 'rectText',
          attrs: { x: startX, y: arrowEndY + 30, text: attr.text, align: 'center', baseline: 'bottom' },
          ignoreEvent: true
        }
      ];
    } else {
      const startX = coordinates[0].x
      const startY = coordinates[0].y - 6
      const lineEndY = startY - 50
      const arrowEndY = lineEndY - 5

      return [
        {
          type: 'line',
          attrs: { coordinates: [{ x: startX, y: startY }, { x: startX, y: lineEndY }] },
          ignoreEvent: true
        },
        {
          type: 'rectText',
          attrs: { x: startX, y: arrowEndY, text: attr.text, align: 'center', baseline: 'bottom' },
          ignoreEvent: true
        }
      ];
    }
  }
}

export default annotation
