/**
 * Custom Value Line Indicator
 */
export const createCustomLineIndicator = (name, data, styles) => {
  return {
    name,
    precision: 8,
    shouldOhlc: false,
    figures: [
      { key: name, title: '', type: 'line', styles: () => {
        return {
          color: styles.color,
          styles
        };
      } },
    ],
    styles: {
      lines: styles.lines
    },
    calc: (dataList, indicator) => {
      let lastValue = 0;
      return dataList.map((kLineData, i) => {
        const r = {};
        const v = parseFloat(data[kLineData.timestamp / 1000]?.value || lastValue) || 0;
        r[name] = v;
        lastValue = v;
        return r;
      })
    }
  }
}

